<?php

if(isset($_GET['mdocs-file']) || isset($_GET['is-google']) || isset($_GET['mdocs-version']) || isset($_GET['mdocs-export-file'])) mdocs_download_file();
if(isset($_GET['mdocs-img-preview']) ) { mdocs_preview_image(); }
function mdocs_preview_image() { add_action( 'plugins_loaded', 'mdocs_load_plugins_for_image_preview' ); }
function mdocs_download_file() { add_action( 'plugins_loaded', 'mdocs_load_plugins_for_download' ); }
function mdocs_load_plugins_for_download() {
	$mdocs = get_option('mdocs-list');
	$upload_dir = wp_upload_dir();
	$is_allowed = false;
	// IS GOOGLE PREVIEW
	if(isset($_GET['is-google'])) {
		$is_google = true;
		$the_mdoc = get_the_mdoc_by(basename($_GET['is-google']), 'id');
		$filename = $the_mdoc['filename'];
		$file = $upload_dir['basedir'].'/mdocs/'.$filename;
	} else $is_google = false;
	// IS BOXVIEW PREVIEW
	if(isset($_GET['is-box-view'])) $is_box_view = true;
	else $is_box_view = false;
	// CHECK TYPE OF DOWNLOAD
	if(isset($_GET['mdocs-export-file']) ) {
		$is_allowed = mdocs_check_file_rights(null, false);
		$filename = basename($_GET['mdocs-export-file']);
		$file = sys_get_temp_dir().'/'.$filename;
	} elseif(isset($_GET['mdocs-version']) ) {
		$the_mdoc = get_the_mdoc_by(basename($_GET['mdocs-file-id']), 'id');
		$is_allowed = mdocs_check_file_rights($the_mdoc, false);
		$file = $upload_dir['basedir'].'/mdocs/'.basename($_GET['mdocs-version']);
		$filename = substr(basename($_GET['mdocs-version']), 0, strrpos(basename($_GET['mdocs-version']), '-'));
	} elseif(isset($_GET["mdocs-file"])) {
		$the_mdoc = get_the_mdoc_by($_GET["mdocs-file"], 'id');
		$is_allowed = mdocs_check_file_rights($the_mdoc, false);
		$filename = $the_mdoc['filename'];
		$file = $upload_dir['basedir'].'/mdocs/'.$filename;
	} elseif($is_google == false || $is_box_view == false) {
		//mdocs_errors(__('Something when wrong, and your download has failed.'), 'error');
	}
	// COUNT THE DOWNLOAD
	if($is_allowed && !isset($_GET['mdocs-export-file']) && !isset($_GET['mdocs-version']) && $is_box_view === false && $is_google === false) {
		$mdocs[$the_mdoc['index']]['downloads'] = intval($mdocs[$the_mdoc['index']]['downloads'])+1;
		mdocs_save_list($mdocs);
	}
	$filetype = wp_check_filetype($file);
	if($is_allowed  || $is_box_view || $is_google) {
		if (file_exists($file)  ) {
			header('Content-Description: File Transfer');
			header('Content-Type: '.$filetype['type']);
			header('Content-Disposition: attachment; filename='.$filename);
			header('Content-Transfer-Encoding: binary');
			header('Expires: 0');
			header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
			header("Cache-Control: private",false); 
			header('Pragma: public');
			header('Content-Length: ' . filesize($file));
			ob_clean();
			flush();
			readfile($file);
			exit;
		} else if(!file_exists($file) && $is_box_view == true) die(__('Memphis Documents Error','mdocs').': '.basename($file).' '.__('was not found, no preview created for this file.', 'mdocs'));
		else {
			die(__('Memphis Documents Error','mdocs').': <b>'.basename($file).'</b> '.__('was not found, please contact the owner for assistance.', 'mdocs'));
		}
	} else die(__('Sorry you are unauthorized to download this file.','mdocs'));
	
}
// IMAGE PREVIEW
function mdocs_load_plugins_for_image_preview() {
	$image_file = sanitize_text_field($_GET['mdocs-img-preview']);
	$image_file = sanitize_file_name( $image_file );
	$upload_dir = wp_upload_dir();
	$image = $upload_dir['basedir'].MDOCS_DIR.basename($image_file); 
	$content = file_get_contents($image);
	header('Content-Type: image/jpeg');
	echo $content; exit();
}
// EXPORT DOWNLOAD
function mdocs_download_export_file($file) {
	$filename = $file;
	$file = sys_get_temp_dir()."/".$file;
	if (file_exists($file)) {		
			header('Content-Description: File Transfer');
			header('Content-Type: application/zip');
			header('Content-Disposition: attachment; filename='.$filename);
			header('Content-Transfer-Encoding: binary');
			header('Expires: 0');
			header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
			header("Cache-Control: private",false); 
			header('Pragma: public');
			header('Content-Length: ' . filesize($file));
			ob_clean();
			flush();
			readfile($file);
			exit;
	} else mdocs_errors(__('Memphis Documents Error','mdocs').': '.basename($file).' '.__('was not found, file not exported.', 'mdocs'), 'error');
}
?>