<?php
$the_rating = array();
function mdocs_edit_file($the_mdocs, $index, $current_cat) {
	?>
	<div class="mdocs-edit-file">
		<span class="update" id="<?php echo $index ?>">
			<i class="fa fa-pencil"></i> <a href="<?php echo 'admin.php?page=memphis-documents.php&mdocs-cat='.$current_cat.'&action=update-doc&mdocs-index='.$index; ?>" title="Update this file" class="edit"><?php _e('Update','mdocs'); ?></a> |
		</span>
		<span class='delete'>
			<i class="fa fa-remove"></i> <a class='submitdelete' onclick="return showNotice.warn();" href="<?php echo 'admin.php?mdocs-nonce='.$_SESSION['mdocs-nonce'].'&page=memphis-documents.php&mdocs-cat='.$current_cat.'&action=delete-doc&mdocs-index='.$index; ?>"><?php _e('Delete','mdocs'); ?></a> |
		</span>
		<span class="versions">
			<i class="icon-off"></i> <a href="<?php echo 'admin.php?page=memphis-documents.php&mdocs-cat='.$current_cat.'&mdocs-index='.$index; ?>&action=mdocs-versions" title="<?php _e('Versions','mdocs'); ?>" class="edit"><?php _e('Versions','mdocs'); ?></a></span>
	</div>
	<?php
}

function  mdocs_display_tabs($the_mdoc) {
	$mdocs_default_content = get_option('mdocs-default-content');
	$mdocs_show_description = get_option('mdocs-show-description');
	$mdocs_show_preview = get_option('mdocs-show-preview');
	$mdocs_show_versions = get_option('mdocs-show-versions');
	ob_start();
	if($mdocs_show_description) {
		?><a class="mdocs-nav-tab <?php if($mdocs_default_content=='description') echo 'mdocs-nav-tab-active'; ?>" data-mdocs-show-type="desc" data-mdocs-id="<?php echo $the_mdoc['id']; ?>"><?php _e('Description', 'mdocs'); ?></a><?php
	}
	if($mdocs_show_preview) {
		?><a class="mdocs-nav-tab <?php if($mdocs_default_content=='preview') echo 'mdocs-nav-tab-active'; ?>"  data-mdocs-show-type="preview" data-mdocs-id="<?php echo $the_mdoc['id']; ?>"><?php _e('Preview', 'mdocs'); ?></a><?php
	}
	if($mdocs_show_versions) {
		?><a class="mdocs-nav-tab <?php if($mdocs_default_content=='versions') echo 'mdocs-nav-tab-active'; ?>"  data-mdocs-show-type="versions" data-mdocs-id="<?php echo $the_mdoc['id']; ?>"><?php _e('Versions', 'mdocs'); ?></a><?php
	}
	?>
	<div class="mdocs-show-container" id="mdocs-show-container-<?php echo $the_mdoc['id']; ?>">
		<?php
		if(!isset($_POST['show_type']) && $mdocs_show_description && $mdocs_default_content == 'description') {
			mdocs_show_description($the_mdoc['id']);
		} elseif(!isset($_POST['show_type']) && $mdocs_show_preview && $mdocs_default_content == 'preview') {
			mdocs_show_preview($the_mdoc);
		} elseif(!isset($_POST['show_type']) && $mdocs_show_versions && $mdocs_default_content == 'versions') {
			mdocs_show_versions($the_mdoc['parent']);
		}
		?>
	</div>
	<?php
	$the_des = ob_get_clean();
	return $the_des;
}

function mdocs_rename_file($upload, $file_name) {
	$upload_dir = wp_upload_dir();
	$index = 0;
	$org_filename = $file_name;
	while(file_exists($upload_dir['basedir'].'/mdocs/'.$file_name)) {
		$index++;
		$explode = explode('.',$org_filename);
		$tail = $index.'.'.$explode[count($explode)-1];
		array_pop($explode);
		$file_name = implode('',$explode).$tail;
	}
	$upload['url'] = $upload_dir['baseurl'].'/mdocs/'.$file_name;
	$upload['file'] = $upload_dir['basedir'].'/mdocs/'.$file_name;
	$upload['filename'] = $file_name;
	$name = substr($file_name, 0, strrpos($file_name, '.') );
	if(!isset($_POST['mdocs-name']) || $_POST['mdocs-name'] == '') $upload['name'] = $name;
	else $upload['name'] = $_POST['mdocs-name'];
	return $upload;
}
/**
 * Returns an array of date values.
 * @param string $date The date string sent to be converted. eg 02-12-2016 9:12am
 * @param float $time_offset If sending a time that is not UTC
 * @return array The date array.
 */
function mdocs_format_date($date, $time_offset=0) {
	date_default_timezone_set('UTC');
	$date_format = get_option('mdocs-date-format');
	$formated_dates = array();
	if(method_exists('DateTime', 'createFromFormat')) {
		$dtime = DateTime::createFromFormat($date_format, $date);
		if($dtime != false) {
			$gmdate = $formated_dates['gmdate'] = floatval($dtime->getTimestamp()-$time_offset);
			$formated_dates['date'] = $gmdate+MDOCS_TIME_OFFSET;
			$formated_dates['formated-date'] = date($date_format,$formated_dates['date']);
			$formated_dates['wp-date'] = date('Y-m-d H:i:s',$formated_dates['date']);
			$formated_dates['wp-gmdate'] = date('Y-m-d H:i:s',$gmdate);
		} else {
			$gmdate = $formated_dates['gmdate'] = time();
			$formated_dates['date'] = $gmdate+MDOCS_TIME_OFFSET;
			$formated_dates['formated-date'] = date($date_format,$formated_dates['date']);
			$formated_dates['wp-date'] = date('Y-m-d H:i:s',$formated_dates['date']);
			$formated_dates['wp-gmdate'] = date('Y-m-d H:i:s',$gmdate);
		}
	} else {
		$gmdate = $formated_dates['gmdate'] = time();
		$formated_dates['date'] = $gmdate+MDOCS_TIME_OFFSET;
		$formated_dates['formated-date'] = date($date_format,$formated_dates['date']);
		$formated_dates['wp-date'] = date('Y-m-d H:i:s',$formated_dates['date']);
		$formated_dates['wp-gmdate'] = date('Y-m-d H:i:s',$gmdate);
	}
	return $formated_dates;
}
/**
 * Returns an array of date values.
 * @param float $gmdate The unix epoch date sent to be converted. eg 1486199520
 * @return array The date array.
 */
function mdocs_format_unix_epoch($gmdate=null) {
	date_default_timezone_set('UTC');
	if($gmdate == null) $gmdate = time();
	$date_format = get_option('mdocs-date-format');
	$formated_dates = array();
	$formated_dates['gmdate'] = $gmdate;
	$formated_dates['date'] = $gmdate+MDOCS_TIME_OFFSET;
	$formated_dates['formated-date'] = date($date_format, $formated_dates['date']);
	$formated_dates['wp-date'] = date('Y-m-d H:i:s', $formated_dates['date']);
	$formated_dates['wp-gmdate'] = date('Y-m-d H:i:s', $gmdate);
	return $formated_dates;
}
/**
 * Returns the Memphis Documents data.
 * @param string $search_value The value to search for.
 * @param string $search_index The array key to use for searching for the documents array data.
 * @ return An array of data for the specific document.
 */
function get_the_mdoc_by($search_value, $search_index) {
	$mdocs = get_option('mdocs-list');
	foreach($mdocs as $index => $doc) {
		if($search_value == $doc[$search_index]) {
			$doc['index'] = $index;
			return $doc;
			break;
		}
	}
}
/**
 * Checks whether to hide the file type icon if false, then return a html image string of the files type.
 * @param array $the_mdoc The mDocs file to be processsed
 * @return string An html string of the files type.
 */
function mdocs_get_file_type_icon($the_mdoc) {
	if(get_option('mdocs-hide-file-type-icon') == false) {
		$file_type = wp_check_filetype($the_mdoc['filename']);
		if($file_type['ext'] == false) {
			$exp = explode('.',$the_mdoc['filename']);
			$file_type['ext'] = $exp[1];
		}
		if(file_exists(MDOC_PATH.'assets/imgs/filetype-icons/'.$file_type['ext'].'.png'))  return '<img src="'.plugins_url().'/memphis-documents-library/assets/imgs/filetype-icons/'.$file_type['ext'].'.png" class="hidden-xs hidden-sm hidden-md"/>';
		else $return = '<img src="'.plugins_url().'/memphis-documents-library/assets/imgs/filetype-icons/unknow.png" class="hidden-xs hidden-sm hidden-md"/>';
	}
}
/**
 * Removes a diretory and all of it files and child directories.
 * @param string $the_dir The full path to the directory to be removed.
 */
function mdocs_rmdir($the_dir) {
	$the_children = glob($the_dir.'/*'); 
	foreach($the_children as $the_child){
		if(is_dir($the_child)) {
			mdocs_rmdir($the_child);
		} elseif(is_file($the_child)) {
			unlink($the_child);
		}
	}
	$hidden = preg_grep('/^\.\w+/', scandir($the_dir."/"));
	foreach($hidden as $file) {
		unlink($the_dir.'/'.$file);
	}
	rmdir($the_dir);
}
/**
 * Sanitizes an array and returns a safe version of the data in the array.
 * @param array $array The array to be sanitized.
 * @return The sanitized array.
 */
function mdocs_sanitize_array($array) {
	foreach($array as $index => $array_value) {
		if($index != 'mdocs-desc') {
			$array[$index] = sanitize_text_field($array_value);
			$array[$index] = preg_replace('/[^A-Za-z0-9 \-._]/', '', $array[$index]);
		} elseif($index == 'mdocs-desc') {
			$array[$index] = wp_kses_post($array_value);
		}
	}
	return $array;
}
/**
 * Uploads the file and created a mDocs post.
 * @param array $file The files properties.
 * @param boolean $import A boolean value that checks if the file to be processed is an imported file.
 */
function mdocs_process_file($file, $import=false) {
	global $current_user;
	require_once(ABSPATH . 'wp-admin/includes/image.php');
	if(isset($_POST['mdocs-type'])) $mdocs_type = $_POST['mdocs-type'];
	else $mdocs_type = null;
	$post_status = $file['post-status'];
	if($import) $desc = $file['desc'];
	elseif(isset($_POST['mdocs-desc'])) $desc = $_POST['mdocs-desc'];
	else $desc = '';
	$upload_dir = wp_upload_dir();
	if($import == false && isset($_POST['mdocs-last-modified'])) {
		$the_date = mdocs_format_date($_POST['mdocs-last-modified'], MDOCS_TIME_OFFSET);
	} elseif($import) $the_date = mdocs_format_unix_epoch($file['modifed']);
	else $the_date = mdocs_format_unix_epoch();
	if($file['error'] > 0) {
		$upload['error'] = __('An Error has occured.','mdocs');
		return $upload;
	}
	if($import == false) {
		$upload['url'] = $upload_dir['baseurl'].'/mdocs/'.$file['name'];
		$upload['file'] = $upload_dir['basedir'].'/mdocs/'.$file['name'];
		$upload['filename'] = $file['name'];
		if(file_exists($upload_dir['basedir'].'/mdocs/'.$file['name'])) $upload = mdocs_rename_file($upload, $file['name']);
		else {
			$name = substr($file['name'], 0, strrpos($file['name'], '.') );
			if(!isset($_POST['mdocs-name']) || $_POST['mdocs-name'] == '') $upload['name'] = $name;
			else $upload['name'] = $_POST['mdocs-name'];
		}
		$result = move_uploaded_file($file['tmp_name'], $upload['file']);
		if($result == false) rename($file['tmp_name'], $upload['file']);
	} else {
		$upload['url'] = $upload_dir['baseurl'].'/mdocs/'.$file['filename'];
		$upload['file'] = $upload_dir['basedir'].'/mdocs/'.$file['filename'];
		$upload['filename'] = $file['filename'];
		$upload['name'] = $file['name'];
	}
	$wp_filetype = wp_check_filetype($upload['file'], null );
	if($the_date['wp-date'] > time() && $post_status === 'publish') $post_status = 'future';
	else $post_status = (string)$post_status;
	if($mdocs_type == 'mdocs-add' || $import == true) {
		$mdocs_post = array(
			'post_title' => $upload['name'],
			'post_status' => $post_status,
			'post_content' => '[mdocs_post_page new=true]',
			'post_author' => $current_user->ID,
			'post_excerpt' => $desc,
			'post_date' => $the_date['wp-date'],
			'post_date_gmt' => $the_date['wp-gmdate'],
			'post_type' => 'mdocs-posts',
		);
		$mdocs_post_id = wp_insert_post( $mdocs_post, true );
		$attachment = array(
			'post_mime_type' => $wp_filetype['type'],
			'post_title' => preg_replace('/\.[^.]+$/', '', basename($upload['name'])),
			'post_content' => '[mdocs_media_attachment]',
			'post_author' => $current_user->ID,
			'post_status' => 'inherit',
			'post_excerpt' => $upload['url'],
			'comment_status' => 'closed',
			'post_date' => $the_date['wp-date'],
			'post_date_gmt' => $the_date['wp-gmdate'],
		 );
		$mdocs_attach_id = wp_insert_attachment( $attachment, $upload['file'], $mdocs_post_id );
		$mdocs_attach_data = wp_generate_attachment_metadata( $mdocs_attach_id, $upload['file'] );
		wp_update_attachment_metadata( $mdocs_attach_id, $mdocs_attach_data );
		$upload['parent_id'] = $mdocs_post_id;
		$upload['attachment_id'] = $mdocs_attach_id;
		if($import == false && isset($_POST['mdocs-tags'])) wp_set_post_tags($mdocs_post_id, $_POST['mdocs-tags']);
	} elseif($mdocs_type == 'mdocs-update') {
		$mdocs_post = array(
			'ID' => $file['parent'],
			'post_title' => $upload['name'],
			'post_status' =>$post_status,
			'post_content' => '[mdocs_post_page]',
			'post_author' => $current_user->ID,
			'post_excerpt' => $desc,
			'post_date' => $the_date['wp-date'],
			'post_date_gmt' => $the_date['wp-gmdate'],
		);
		$mdocs_post_id = wp_update_post( $mdocs_post );
		$attachment = array(
			'ID' => $file['id'],
			'post_mime_type' => $wp_filetype['type'],
			'post_title' => $upload['name'],
			'post_content' => '[mdocs_media_attachment]',
			'post_author' => $current_user->ID,
			'post_status' => 'inherit',
			'post_excerpt' => $upload['url'],
			'post_date' => $the_date['wp-date'],
			'post_date_gmt' => $the_date['wp-gmdate'],
		 );
		update_attached_file( $file['id'], $upload['file'] );
		$mdocs_attach_id = wp_update_post( $attachment );
		$mdocs_attach_data = wp_generate_attachment_metadata( $mdocs_attach_id, $upload['file'] );
		wp_update_attachment_metadata( $mdocs_attach_id, $mdocs_attach_data );
		//wp_set_post_tags( $mdocs_post_id, $upload['name'].', memphis documents library, '.$wp_filetype['type'] );
		wp_set_post_tags($mdocs_post_id, $_POST['mdocs-tags']);
	}
	$upload['desc'] = $desc;
	$upload['modified'] = $the_date['gmdate'];
	return $upload;
}

function mdocs_nonce() {
	if(!session_id()) {
		session_start();
		//session_start([ 'mdocs-nonce' => md5(rand(0,1000000))]);
	}
	if(get_option('mdocs-disable-sessions') == false) {
		if(isset($_SESSION['mdocs-nonce'])) define('MDOCS_NONCE',$_SESSION['mdocs-nonce']);
		if(!isset($_SESSION['mdocs-nonce']) || isset($_REQUEST['mdocs-nonce'])) $_SESSION['mdocs-nonce'] = md5(rand(0,1000000));
	} else {
		define('MDOCS_NONCE', md5(rand(0,1000000)));
		$_SESSION['mdocs-nonce'] = null;
	}
}
function mdocs_is_sessions_enabled() {
	if ( version_compare(phpversion(), '5.4.0', '>=') ) {
		$session_status = session_status();
		if($session_status === 0 || $session_status === PHP_SESSION_DISABLED) return false;
		else return true;
	} else {
		return session_id() === '' ? false : true;
	}
}
function mdocs_array_sort($the_array=null, $orderby=null, $sort_types=null) {
	if($the_array == null) $the_array = get_option('mdocs-list');
	if($orderby == null) $orderby = get_option('mdocs-sort-type');
	if($sort_types == null) $sort_types = get_option('mdocs-sort-style');
	$disable_user_sort = get_option('mdocs-disable-user-sort');
	if($disable_user_sort == false) {
		$sort_types = get_option('mdocs-sort-style');
		if(isset($_COOKIE['mdocs-sort-type'])) $orderby = $_COOKIE['mdocs-sort-type'];
		if(isset($_COOKIE['mdocs-sort-range'])) $sort_types = $_COOKIE['mdocs-sort-range'];
	}
	if($sort_types == 'desc') $sort_types = SORT_DESC;
	if($sort_types == 'asc') $sort_types = SORT_ASC;
    if($the_array != null) {
		foreach($the_array as $a){ 
			foreach($a as $key=>$value){ 
				if(!isset($sortArray[$key])){ 
					$sortArray[$key] = array(); 
				} 
				$sortArray[$key][] = $value; 
			} 
		}
		$array_lowercase = array_map('strtolower', $sortArray[$orderby]);
		if(is_numeric($array_lowercase[0])) $sort_var_type = SORT_NUMERIC;
		else $sort_var_type = SORT_STRING;
		array_multisort($array_lowercase, $sort_types, $sort_var_type,$the_array);
		$the_array = array_values($the_array);
		return $the_array;
	} else return array();
}

function mdocs_errors($error, $type='updated') {
	if($type == 'error') $error = '<b>'.__('Memphis Error','mdocs').': </b>'.$error;
	else $error = '<b>'.__('Memphis Info','mdocs').': </b>'.$error;
	?>
	<div class="<?php echo $type; ?>" style="clear:both;">
		<div id="mdocs-error">
		<p><?php _e($error); ?></p>
		</div>
	</div>
    <?php
}
/**
 * Checks whether the mdocs folder is read and writable.
 * @return boolean Returns a boolean value true for read and writable and false if not.
 */
function mdocs_check_read_write() {
	$is_read_write = false;
	$upload_dir = wp_upload_dir();
	if(is_readable($upload_dir['basedir']) && is_writable($upload_dir['basedir'])) $is_read_write = true;
	return $is_read_write;
}
/**
 * This function outputs a dropdown list of all folders created. 
 * @param array $folders The current level of the folder array.
 * @param string $current_folder The current folder being displayed.
 * @param int $depth The current depth of the folders array.
 * @param boolean $echo Weather to show or hide this dropdown menu.
 */
function mdocs_display_folder_options_menu($folders, $current_folder='', $depth=0, $echo=true) {
	$nbsp = '';
	for($i=0;$i < $depth;$i++) $nbsp .= '&nbsp;&nbsp;';
	foreach( $folders as $index => $cat ){
		if($current_folder === $cat['slug']) $is_selected = 'selected="selected"';
		else $is_selected = '';
		if($echo) echo '<option  value="'.$cat['slug'].'" '.$is_selected.'>'.$nbsp.$cat['name'].'</option>';
		if(count($cat['children']) > 0) { 
			mdocs_display_folder_options_menu($cat['children'], $current_folder ,$cat['depth']+1);
		}
	}
}
/**
 * Searches an array of data and returns the value.
 * @param array $array The array to search.
 * @param string $search The value to search for.
 * @return array The value searched for.
 */
function mdocs_recursive_search($array, $search='') {
    if ($array) {
        foreach ($array as $index => $value) {
            if (is_array($value)) {
                $result = mdocs_recursive_search($value, $search);
				if($result != null) return $result;
            } else {
				if($search === $value) return $array;
            }
        }
    }
}
/**
 * Returns the folder data.
 * @param string|array $current_folder The current category that the user is in.
 * @return array The folder data.
 */
function mdocs_get_the_folder($current_folder=null, $shortcode=null) {
	$cats =  get_option('mdocs-cats');
	if(is_string($current_folder) && $current_folder != '') $current_folder = $current_folder;
	elseif($current_folder != null && !isset($_GET['mdocs-cat']) && isset($current_folder['cat'])) $current_folder = $current_folder['cat'];
	elseif(isset($_GET['mdocs-cat']) && $current_folder == null) $current_folder = $_GET['mdocs-cat'];
	
	elseif(isset($_GET['att']) && $shortcode != $_GET['att']) $current_folder = $shortcode;
	
	
	elseif(isset($_GET['mdocs-cat']) && $current_folder != null) $current_folder = $_GET['mdocs-cat'];
	else $current_folder = $cats[0]['name'];
	return mdocs_recursive_search(get_option('mdocs-cats'),$current_folder);
}
/**
 * Displays the sub folders of a parent folder, also returns the number of columns to display.
 * @param string $current_cat The current category that the user is in.
 * @return int The number of columns to display.
 */
function mdocs_display_sub_folders($current_cat, $att=null) {
	global $post;
	if(!is_admin()) {
		$permalink = get_permalink($post->ID);
		if(preg_match('/\?page_id=/',$permalink) || preg_match('/\?p=/',$permalink)) {
			$permalink = $permalink.'&mdocs-cat=';
		} else $permalink = $permalink.'?mdocs-cat=';
	} else $permalink = 'admin.php?page=memphis-documents.php&mdocs-cat=';
	if(is_admin()) $num_cols = 2;
	else $num_cols = 1;
	if(get_option('mdocs-show-downloads') == '1' || get_option('mdocs-show-downloads')) $num_cols++;
	if(get_option('mdocs-show-author') == '1' || get_option('mdocs-show-author')) $num_cols++;
	if(get_option('mdocs-show-version') == '1' || get_option('mdocs-show-version')) $num_cols++;
	if(get_option('mdocs-show-update') == '1' || get_option('mdocs-show-update')) $num_cols++;
	if(get_option('mdocs-show-ratings') == '1' || get_option('mdocs-show-ratings')) $num_cols++;
	if(get_option('mdocs-show-download-btn') == '1' || get_option('mdocs-show-download-btn')) $num_cols++;
	if(get_option('mdocs-list-type') == 'large') echo '<table class="mdocs-list-table">';
	$parent_cat_string = '';
	$current_cat_string = '';
	$child_cats_string = '';
	if($current_cat['parent'] != '') {
		$parent_cat = mdocs_get_the_folder($current_cat['parent']);
		$parent_cat_string = '
			<tr class="mdocs-parent-cat" >
				<td colspan="'.$num_cols.'" id="title" class="mdocs-tooltip">
					<a href="'.$permalink.$parent_cat['slug'].'&att='.$att.'" title="'.$permalink.$parent_cat['slug'].'">
					<i class="fa fa-reply"></i> '.$parent_cat['name'].'</a>
				</td>
			</tr>';
	}
	
	$current_cat_string = '
		<tr class="mdocs-current-cat" >
			<td colspan="'.$num_cols.'" id="title" class="mdocs-tooltip">
				<p><i class="fa fa fa-folder-open-o"></i> '.$current_cat['name'].'</p>
			</td>
		</tr>';
	if(isset($current_cat['children']) && count($current_cat['children']) > 0) {
		foreach($current_cat['children'] as $index => $child) {
			$child_cats_string .= '
			<tr class="mdocs-sub-cats" >
				<td colspan="'.$num_cols.'" id="title" class="mdocs-tooltip">
					<a href="'.$permalink.$child['slug'].'&att='.$att.'" title="'.$child['name'].'"><i class="fa fa-folder-o"></i> '.$child['name'].'</a>
				</td>
			</tr>';
			
		}
	}
	if(get_option('mdocs-show-current-folder-on-top')) echo $current_cat_string.$parent_cat_string.$child_cats_string;
	else echo $parent_cat_string.$child_cats_string.$current_cat_string;
	
	if(get_option('mdocs-list-type') == 'large') echo '</table>';
	return $num_cols;
}

function mdocs_custom_mime_types($existing_mimes=array()) {
	// Add file extension 'extension' with mime type 'mime/type'
	$mdocs_allowed_mime_types = get_option('mdocs-allowed-mime-types');
	foreach($mdocs_allowed_mime_types as $index => $mime) {
		$existing_mimes[$index] = $mime;
	}
	$mdocs_removed_mime_types = get_option('mdocs-removed-mime-types');
	foreach($mdocs_removed_mime_types as $index => $mime) {
		unset($existing_mimes[$mime]);
	}
	return $existing_mimes;
}

function mdocs_list_header($show=true) {
	mdocs_load_modals();
	$current_cat = mdocs_get_current_cat();
	if($show) {
		global $post;
		$mdocs = get_option('mdocs-list');
		$num_docs = count($mdocs);
		$cats = get_option('mdocs-cats');
		$upload_dir = wp_upload_dir();
		$message = '';
		
		if($post == null) $is_admin = true;
		else {
			$is_admin = false;
			$permalink = get_permalink($post->ID);
			if(preg_match('/\?page_id=/',$permalink) || preg_match('/\?p=/',$permalink)) {
				$permalink = $permalink.'&mdocs-cat=';
			} else $permalink = $permalink.'?mdocs-cat=';
		}
		
		?>
		<div class="mdocs-wrap">
			
			<div class="mdocs-admin-preview"></div>
			<?php if($message != "" && $type != 'update') { ?> <div id="message" class="error" ><p><?php _e($message); ?></p></div> <?php }?>
			<?php if(is_admin()) { ?>
			<h2><?php _e("Documents Library",'mdocs'); ?></h2>
			<?php
			// ERRORS AND UPDATES
			if(isset($_FILES['mdocs']) && $_FILES['mdocs']['name'] == '' && $_POST['mdocs-type'] == 'mdocs-add')  { mdocs_errors(MDOCS_ERROR_1,'error');  }
			?>
			<div class="btn-group">
				<a class="add-update-btn btn btn-danger btn-sm" data-toggle="modal" data-target="#mdocs-add-update" data-mdocs-id="" data-is-admin="<?php echo is_admin(); ?>" data-action-type="add-doc"  data-current-cat="<?php echo $current_cat; ?>" href=""><?php _e('Add New Document','mdocs'); ?> <i class="fa fa-upload fa-lg"></i></a>
			</div>
			<?php
			if (current_user_can( 'manage_options' )) {
			?>
			<div class="btn-group">
				<button class="btn btn-default dropdown-toggle btn-sm" type="button" id="dropdownMenu1" data-toggle="dropdown"><?php _e('Options','mdocs'); ?><span class="caret"></span></button>
				<ul class="dropdown-menu" role="menu" aria-labelledby="dropdownMenu1">
					 <li role="presentation" class="dropdown-header"><?php _e('File Options','mdocs'); ?></li>
				  <li role="presentation"><a role="menuitem" tabindex="-1" href="?page=memphis-documents.php&mdocs-cat=cats"><?php _e('Edit Folders','mdocs'); ?></a></li>
				  <li role="presentation"><a role="menuitem" tabindex="-1" href="?page=memphis-documents.php&mdocs-cat=allowed-file-types"><?php _e('Allowed File Types','mdocs'); ?></a></li>
				  <li role="presentation"><a role="menuitem" tabindex="-1" href="?page=memphis-documents.php&mdocs-cat=import"><?php _e('Import','mdocs'); ?></a></li>
				  <li role="presentation"><a role="menuitem" tabindex="-1" href="?page=memphis-documents.php&mdocs-cat=export"><?php _e('Export','mdocs'); ?></a></li>
				  <li role="presentation"><a role="menuitem" tabindex="-1" href="?page=memphis-documents.php&mdocs-cat=batch"><?php _e('Batch Upload'); ?></a></li>
				  <li role="presentation" class="divider"></li>
				  <li role="presentation" class="dropdown-header"><?php _e('Admin Options','mdocs'); ?></li>
				  <li role="presentation"><a role="menuitem" tabindex="-1" href="?page=memphis-documents.php&mdocs-cat=settings"><?php _e('Settings','mdocs'); ?></a></li>
				  <li role="presentation"><a role="menuitem" tabindex="-1" href="?page=memphis-documents.php&mdocs-cat=find-lost-files"><?php _e('Find Lost Files','mdocs'); ?></a></li>
				  <li role="presentation"><a role="menuitem" tabindex="-1" href="?page=memphis-documents.php&mdocs-cat=filesystem-cleanup"><?php _e('File System Cleanup','mdocs'); ?></a></li>
				   <li role="presentation"><a role="menuitem" tabindex="-1" href="?page=memphis-documents.php&mdocs-cat=restore"><?php _e('Restore To Default','mdocs'); ?></a></li>
					<li role="presentation"><a role="menuitem" tabindex="-1" href="?page=memphis-documents.php&mdocs-cat=short-codes"><?php _e('Short Codes','mdocs'); ?></a></li>
					<li role="presentation"><a role="menuitem" tabindex="-1" href="?page=memphis-documents.php&mdocs-cat=server-compatibility"><?php _e('Test Server Compatibility','mdocs'); ?></a></li>
					<?php
					if(get_option('mdocs-preview-type') == 'box' && get_option('mdocs-box-view-key') != '') {
					  ?>
					  
					  <li role="presentation"><a class="success" role="menuitem" tabindex="-1" href="#" id="mdosc-3-0-patch-btn" data-num-docs="<?php echo $num_docs; ?>"><?php _e('Run Box View Preview and Thumbnail Updater','mdocs'); ?></a></li>
					  <?php } ?>
				</ul>
			</div>
			<?php } ?>
			<br><br>
			<?php } ?>
			<div class="mdoc-navbar-container">
				<?php
				if(get_option('mdocs-hide-navbar') == false || is_admin()) {
				?>
				<nav class="navbar mdocs-navbar-default" role="navigation" id="mdocs-navbar">
					<div class="container-fluid">
						<div class="navbar-header">
							<button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#mdocs-navbar-collapse">
							  <span class="sr-only">Toggle navigation</span>
							  <span class="icon-bar"></span>
							  <span class="icon-bar"></span>
							  <span class="icon-bar"></span>
							</button>
							<span class="navbar-brand"><?php _e('Folders','mdocs'); ?></span>
						</div>
						<div class="collapse navbar-collapse" id="mdocs-navbar-collapse">
							<ul class="nav navbar-nav">
								<?php
								if(!empty($cats)) {
									foreach( $cats as $index => $cat ){
										if($is_admin) echo '<li><a href="?page=memphis-documents.php&mdocs-cat='.$cat['slug'].' ">'.__($cat['name']).'</a></li>';
										else echo '<li><a href="'.$permalink.$cat['slug'].'">'.__($cat['name']).'</a></li>';
									}
								}
								?>
							</ul>
						</div>
					</div>
				</nav>
			</div>
			<?php } ?>
		</div>
		<?php
		
	} else {
		echo '<div class="mdocs-wrap"></div>';
	}
	return $current_cat;
}

function mdocs_get_current_cat($atts=null) {
	$cats =  get_option('mdocs-cats');
	$current_cat = '';
	if(isset($_GET['mdocs-cat']) && !isset($atts['cat'])) $current_cat = $_GET['mdocs-cat'];
	elseif(!is_string($cats) && !isset($atts['cat'])) $current_cat = $cats[0]['slug'];
	elseif(isset($_GET['mdocs-cat']) && isset($atts['cat']) && isset($_GET['att']) &&  $atts['cat'] == $_GET['att']) {
		$cat = mdocs_recursive_search($cats, $_GET['mdocs-cat']);
		$current_cat = $cat['slug'];
	} elseif(isset($atts['cat'])) {
		$cat = mdocs_recursive_search($cats, $atts['cat']);
		$current_cat = $cat['slug'];
	} 
	return $current_cat;
}

// GET ALL MDOCS POST AND DISPLAYS THEM ON THE MAIN PAGE.
add_filter( 'pre_get_posts', 'mdocs_get_posts' );
function mdocs_get_posts( $query ) {
	$remove_post_from_homepage = get_option('mdocs-remove-posts-from-homepage');
	if($remove_post_from_homepage) {
		if ( $query->is_search == false && !is_admin() && isset($post) && has_shortcode( $post->post_content, 'mdocs' )) {
			if(get_option('mdocs-hide-all-posts') == false && get_option('mdocs-hide-all-posts-non-members') == false) {
				$query->set( 'post_type', array( 'post', 'mdocs-posts' ) );
			} elseif(is_user_logged_in() && get_option('mdocs-hide-all-posts-non-members') == true) {
				$query->set( 'post_type', array( 'post', 'mdocs-posts' ) );
			}
		}
	} else {
		if ( is_home() && $query->is_main_query() ||  $query->is_search == false && !is_admin() && isset($post) && has_shortcode( $post->post_content, 'mdocs' )) {
			if(get_option('mdocs-hide-all-posts') == false && get_option('mdocs-hide-all-posts-non-members') == false) {
				$query->set( 'post_type', array( 'post','media', 'mdocs-posts' ) );
			} elseif(is_user_logged_in() && get_option('mdocs-hide-all-posts-non-members') == true) {
				$query->set( 'post_type', array( 'post','media', 'mdocs-posts' ) );
			}
		}
	}
}
// SHOW HIDE MDOCS MEDIA FILES FROM MENU
if(get_option('mdocs-show-media-files') == false) add_filter( 'posts_where', 'mdocs_hide_attachments' );
function mdocs_hide_attachments( $where ){
    if( is_user_logged_in() ){
		if(basename($_SERVER['REQUEST_URI']) == 'upload.php' || basename($_SERVER['REQUEST_URI']) == 'upload.php?deleted=1') {
			$where .= ' AND post_content!="[mdocs_media_attachment]"';
		}
    }
    return $where;
}
function mdocs_save_list($mdocs_list, $is_empty=false) {
	if($mdocs_list != null || is_array($mdocs_list)) {
		update_option('mdocs-list', $mdocs_list, 'no');
	}
}

function mdocs_nav_size($collapse) {
	if($collapse) {
?>
<style type="text/css" media="screen" id="mdocs-nav-collapse">
	@media (max-width: 10000px) {
		.navbar-header { float: none; }
		.navbar-toggle { display: block; }
		.navbar-collapse { border-top: 1px solid transparent; box-shadow: inset 0 1px 0 rgba(255,255,255,0.1); }
		.navbar-collapse.collapse { display: none!important; }
		.navbar-nav { float: none !important; margin: 7.5px -15px; }
		.navbar-nav>li { float: none; }
		.navbar-nav>li>a { padding-top: 10px; padding-bottom: 10px; }
		.navbar-collapse.collapse.in { display: block!important; }
		.collapsing { overflow: hidden!important; }
		#mdocs-navbar .navbar-collapse ul li { margin: 0; }
	}
</style>
<?php
	} else {
?>
<style type="text/css" media="screen" id="mdocs-nav-expand">
	#mdocs-navbar .navbar-toggle { display: none !important; }
	#mdocs-navbar .navbar-header { float: left; margin: 0;  }
	#mdocs-navbar .navbar-header .navbar-brand  { margin: 0; } 
	#mdocs-navbar .navbar-collapse { display: block; margin: 0px; border: none; }
	#mdocs-navbar .navbar-collapse ul, #mdocs-navbar .navbar-collapse ul li { float: left; height: 50px;}
	#mdocs-navbar .navbar-collapse ul li a { padding: 15px; }
</style>
<?php
	}
}
function mdocs_box_view_update_v3_0() {
	?>
	<style>
		body, html { overflow: hidden; }
		.bg-3-0 { width: 100%; height: 100%; background: #000; position: absolute; top: 0; left: 0; z-index: 9999; padding: 0; margin: 0;  opacity:  0.7;}
		.container-3-0 { position: absolute; top: 50px; z-index: 10000; width: 500px; background: #fff; margin-left: 50%; left: -250px; padding: 10px;}
		.container-3-0 h1 { color: #2ea2cc; }
		.container-3-0 h3 { color: red; }
		.btn-container-3-0 { text-align: center; }
		@media (max-width: 640px) {
			.container-3-0 { width: 360px; left: -180px; z-index: 10000; margin-left: 50%}
		}
	</style>
	<div class="bg-3-0"></div>
	<div class="container-3-0">
		<h1><?php _e('Memphis Documents Library', 'mdocs'); ?></h1>
		<h2><?php _e('Document Preview Updater', 'mdocs'); ?></h2>
		<p><?php _e('Version 3.0 of Memphis Documents Library now uses a new documents preview tool Called', 'mdocs'); ?> <a href="https://box-view.readme.io" target="_blank"><?php _e('Box View', 'mdocs'); ?></a>.</p>
		<p><?php _e('This process requires an update to your Memphis Documents Library, which will be adding information needed for', 'mdocs'); ?> <a href="https://box-view.readme.io" target="_blank"><?php _e('Box View', 'mdocs'); ?></a> <?php _e('to work properly.', 'mdocs'); ?></p>
		<h3><?php _e('Important, Please Read', 'mdocs'); ?></h3>
		<p><b><?php _e('The process depending on the size of your Library can take a long time, so make sure you have the time run this updater.', 'mdocs'); ?></b></p>
		<p><b><?php _e('If you choose not to run this updater now preview will not work.', 'mdocs'); ?></b></p>
		<p><b><?php _e('You may run this process anytime by going to the Settings menu and pressing "Run Preview and Thumbnail Updater".', 'mdocs'); ?></b></p>
		<h3><?php _e('DO NOT LEAVE PAGE ONCE THIS UPDATER HAS STARTER!', 'mdocs'); ?></h3>
		<div class="btn-container-3-0">
			<button id="run-updater-3-0"><?php _e('Run Updater', 'mdocs'); ?></button>
			<button id="not-now-3-0"><?php _e('Not Right Now', 'mdocs'); ?></button>
		</div>
	</div>
	
	<?php
}
function mdocs_search_users($user_search_string, $owner, $contributors) {
	if(!is_array($owner)) $owner = array();
	if(!is_array($contributors)) $contributors = array();
	$wp_roles = get_editable_roles();
	$found_roles = array();
	foreach($wp_roles as $index => $role) {
		if(substr( $index, 0, strlen($user_search_string) ) === strtolower($user_search_string)) $found_roles[$index] = $role['name'];
	}
	$users_filter_search = get_users( array( 'search' => $user_search_string.'*' ) );
	$found_users = array();
	foreach($users_filter_search as $index => $user) $found_users[$user->user_login] = $user->display_name;
	if(count($found_roles) > 0) {
		echo '<h4>Roles</h4>';
		echo '<div class="list-group">';
	} 
	foreach($found_roles as $index => $role) {
		if(!in_array($index, $contributors)) {
			echo '<a href="#" class="list-group-item list-group-item-warning mdocs-search-results-roles" data-value="'.$index.'">'.$role.'</a>';
		}
	}
	if(count($found_roles) > 0) echo '</div>';
	if(count($found_users) > 0) {
		echo '<h4>Users</h4>';
		echo '<div class="list-group">';
	}
	foreach($found_users as $index => $user) {
		if($owner != $index && !in_array($index, $contributors)) {
			echo '<a href="#" class="list-group-item list-group-item-warning mdocs-search-results-users" data-value="'.$index.'" >'.$index.' - ('. $user.')</a>';
		}
	}
	if(count($found_users) > 0) echo '</div>';
}

function mdocs_file_upload_max_size() {
  static $max_size = -1;

  if ($max_size < 0) {
    // Start with post_max_size.
    $max_size = parse_size(ini_get('post_max_size'));

    // If upload_max_size is less, then reduce. Except if upload_max_size is
    // zero, which indicates no limit.
    $upload_max = parse_size(ini_get('upload_max_filesize'));
    if ($upload_max > 0 && $upload_max < $max_size) {
      $max_size = $upload_max;
    }
  }
  return $max_size;
}

function parse_size($size) {
  $unit = preg_replace('/[^bkmgtpezy]/i', '', $size); // Remove the non-unit characters from the size.
  $size = preg_replace('/[^0-9\.]/', '', $size); // Remove the non-numeric characters from the size.
  if ($unit) {
    // Find the position of the unit in the ordered string which is the power of magnitude to multiply a kilobyte by.
    return round($size * pow(1024, stripos('bkmgtpezy', $unit[0])));
  }
  else {
    return round($size);
  }
}


?>
