<?php
add_shortcode( 'mdocs', 'mdocs_shortcode' );
function mdocs_shortcode($att, $content=null) { return mdocs_the_list($att); }
function mdocs_the_list($att=null) {
	global $post, $wp_session;
	ob_start();
	if(mdocs_check_read_write() == false) mdocs_errors(__('Unable to create the directory "mdocs" which is needed by Memphis Documents Library. Its parent directory is not writable by the server?','mdocs'),'error');
	$mdocs = get_option('mdocs-list');
	$mdocs = mdocs_array_sort();
	if(isset($att['cat']))	$current_cat_array = mdocs_get_the_folder($att, $att['cat']);
	else $current_cat_array = mdocs_get_the_folder($att);
	$current_cat = $current_cat_array['slug'];
	if(isset($att['cat']) && $att['cat'] == 'All Files') { $current_cat = 'all'; mdocs_list_header(false); }
	else if(!isset($att['cat'])) mdocs_list_header(true);
	else mdocs_list_header(false);
	
	if(is_array($post)) $permalink = get_permalink($post->ID);
	else $permalink = '';
	if(preg_match('/\?page_id=/',$permalink) || preg_match('/\?p=/',$permalink)) {
		$mdocs_get = $permalink.'&mdocs-cat=';
	} else $mdocs_get = $permalink.'?mdocs-cat=';
	$mdocs_sort_type = get_option('mdocs-sort-type');
	$mdocs_sort_style = get_option('mdocs-sort-style');
	$disable_user_sort = get_option('mdocs-disable-user-sort');
	if(isset($_COOKIE['mdocs-sort-type']) && $disable_user_sort == false) $mdocs_sort_type = $_COOKIE['mdocs-sort-type'];
	if(isset($_COOKIE['mdocs-sort-range']) && $disable_user_sort == false) $mdocs_sort_style = $_COOKIE['mdocs-sort-range'];
	if($mdocs_sort_style == 'desc') $mdocs_sort_style_icon = ' <i class="fa fa-chevron-down"></i>';		
	else $mdocs_sort_style_icon = ' <i class="fa fa-chevron-up"></i>';
?><div class="mdocs-container"><?php
	if(isset($att['header'])) echo '<p>'.__($att['header']).'</p>';
	
	$num_tds = 1;
	if(is_admin()) {
		mdocs_donate_btn();
		?>
		<div class="mdocs-batch-options-container">
			<button class="btn btn-info btn-sm" onclick="mdocs_batch_edit()" data-toggle="mdocs-modal" data-target="#mdocs-batch-edit"><?php _e('Batch Edit', 'mdocs'); ?></button>
			<button class="btn btn-warning btn-sm" onclick="mdocs_batch_move()" data-toggle="mdocs-modal" data-target="#mdocs-batch-move"><?php _e('Batch Move', 'mdocs'); ?></button>
			<button class="btn btn-danger btn-sm" onclick="mdocs_batch_delete()" data-toggle="mdocs-modal" data-target="#mdocs-batch-delete"><?php _e('Batch Delete', 'mdocs'); ?></button>
		</div>
		<?php
	}
	?>
	<table class="table table-hover table-condensed mdocs-list-table">
	<?php
	if(get_option('mdocs-hide-sortbar') == false) { ?>
	<thead>
	<tr class="hidden-sm hidden-xs">
		<?php if(is_admin()) { ?> <th id="batch"><input type="checkbox" name="mdocs-batch-select-all" id="mdocs-batch-select-all"/></th> <?php  $num_tds++; } ?>
		<th class="mdocs-sort-option" data-disable-user-sort="<?php echo $disable_user_sort; ?>" data-sort-type="name" data-current-cat="<?php echo $current_cat; ?>" data-permalink="<?php echo $permalink; ?>"><?php _e('Name','mdocs'); ?><?php if($mdocs_sort_type == 'name') echo $mdocs_sort_style_icon; ?></th>
		<?php if(get_option('mdocs-show-downloads')) { $num_tds++; ?>
		<th class="mdocs-sort-option" data-disable-user-sort="<?php echo $disable_user_sort; ?>" data-sort-type="downloads" data-current-cat="<?php echo $current_cat; ?>" data-permalink="<?php echo $permalink; ?>"><?php _e('Downloads','mdocs'); ?><?php if($mdocs_sort_type == 'downloads') echo $mdocs_sort_style_icon; ?></th><?php } ?>
		<?php if(get_option('mdocs-show-version')) { $num_tds++; ?>
		<th class="mdocs-sort-option" data-disable-user-sort="<?php echo $disable_user_sort; ?>" data-sort-type="version" data-current-cat="<?php echo $current_cat; ?>" data-permalink="<?php echo $permalink; ?>"><?php _e('Version','mdocs'); ?><?php if($mdocs_sort_type == 'version') echo $mdocs_sort_style_icon; ?></th><?php } ?>
		<?php if(get_option('mdocs-show-author')) { $num_tds++; ?>
		<th class="mdocs-sort-option" data-disable-user-sort="<?php echo $disable_user_sort; ?>" data-sort-type="owner" data-current-cat="<?php echo $current_cat; ?>" data-permalink="<?php echo $permalink; ?>"><?php _e('Owner','mdocs'); ?><?php if($mdocs_sort_type == 'owner') echo $mdocs_sort_style_icon; ?></th><?php } ?>
		<?php if(get_option('mdocs-show-update')) { $num_tds++; ?>
		<th class="mdocs-sort-option" data-disable-user-sort="<?php echo $disable_user_sort; ?>" data-sort-type="modified" data-current-cat="<?php echo $current_cat; ?>" data-permalink="<?php echo $permalink; ?>"><?php _e('Last Modified','mdocs'); ?><?php if($mdocs_sort_type == 'modified') echo $mdocs_sort_style_icon; ?></th><?php } ?>
		<?php if(get_option('mdocs-show-ratings')) { $num_tds++; ?>
		<th class="mdocs-sort-option" data-disable-user-sort="<?php echo $disable_user_sort; ?>" data-sort-type="rating" data-current-cat="<?php echo $current_cat; ?>" data-permalink="<?php echo $permalink; ?>"><?php _e('Rating','mdocs'); ?><?php if($mdocs_sort_type == 'rating') echo $mdocs_sort_style_icon; ?></th><?php } ?>
		<?php if(get_option('mdocs-show-download-btn')) { $num_tds++; ?>
		<th class="mdocs-sort-option" data-disable-user-sort="<?php echo $disable_user_sort; ?>" data-sort-type="downloads" data-current-cat="<?php echo $current_cat; ?>" data-permalink="<?php echo $permalink; ?>"><?php _e('Download','mdocs'); ?><?php if($mdocs_sort_type == 'downloads') echo $mdocs_sort_style_icon; ?></th><?php } ?>
	</tr>
	</thead>
	
	
	
	<tfoot>
	<tr class="hidden-sm hidden-xs">
		<?php if(is_admin()) { ?> <th id="batch"><input type="checkbox" name="mdocs-batch-select-all" id="mdocs-batch-select-all"/></th> <?php  $num_tds++; } ?>
		<th class="mdocs-sort-option" data-disable-user-sort="<?php echo $disable_user_sort; ?>" data-sort-type="name" data-current-cat="<?php echo $current_cat; ?>" data-permalink="<?php echo $permalink; ?>"><?php _e('Name','mdocs'); ?><?php if($mdocs_sort_type == 'name') echo $mdocs_sort_style_icon; ?></th>
		<?php if(get_option('mdocs-show-downloads')) { $num_tds++; ?>
		<th class="mdocs-sort-option" data-disable-user-sort="<?php echo $disable_user_sort; ?>" data-sort-type="downloads" data-current-cat="<?php echo $current_cat; ?>" data-permalink="<?php echo $permalink; ?>"><?php _e('Downloads','mdocs'); ?><?php if($mdocs_sort_type == 'downloads') echo $mdocs_sort_style_icon; ?></th><?php } ?>
		<?php if(get_option('mdocs-show-version')) { $num_tds++; ?>
		<th class="mdocs-sort-option" data-disable-user-sort="<?php echo $disable_user_sort; ?>" data-sort-type="version" data-current-cat="<?php echo $current_cat; ?>" data-permalink="<?php echo $permalink; ?>"><?php _e('Version','mdocs'); ?><?php if($mdocs_sort_type == 'version') echo $mdocs_sort_style_icon; ?></th><?php } ?>
		<?php if(get_option('mdocs-show-author')) { $num_tds++; ?>
		<th class="mdocs-sort-option" data-disable-user-sort="<?php echo $disable_user_sort; ?>" data-sort-type="owner" data-current-cat="<?php echo $current_cat; ?>" data-permalink="<?php echo $permalink; ?>"><?php _e('Owner','mdocs'); ?><?php if($mdocs_sort_type == 'owner') echo $mdocs_sort_style_icon; ?></th><?php } ?>
		<?php if(get_option('mdocs-show-update')) { $num_tds++; ?>
		<th class="mdocs-sort-option" data-disable-user-sort="<?php echo $disable_user_sort; ?>" data-sort-type="modified" data-current-cat="<?php echo $current_cat; ?>" data-permalink="<?php echo $permalink; ?>"><?php _e('Last Modified','mdocs'); ?><?php if($mdocs_sort_type == 'modified') echo $mdocs_sort_style_icon; ?></th><?php } ?>
		<?php if(get_option('mdocs-show-ratings')) { $num_tds++; ?>
		<th class="mdocs-sort-option" data-disable-user-sort="<?php echo $disable_user_sort; ?>" data-sort-type="rating" data-current-cat="<?php echo $current_cat; ?>" data-permalink="<?php echo $permalink; ?>"><?php _e('Rating','mdocs'); ?><?php if($mdocs_sort_type == 'rating') echo $mdocs_sort_style_icon; ?></th><?php } ?>
		<?php if(get_option('mdocs-show-download-btn')) { $num_tds++; ?>
		<th class="mdocs-sort-option" data-disable-user-sort="<?php echo $disable_user_sort; ?>" data-sort-type="downloads" data-current-cat="<?php echo $current_cat; ?>" data-permalink="<?php echo $permalink; ?>"><?php _e('Download','mdocs'); ?><?php if($mdocs_sort_type == 'downloads') echo $mdocs_sort_style_icon; ?></th><?php } ?>
	</tr>
	</tfoot>
	
	
	
	
	
	<?php } ?>
	<?php
	// SUB CATEGORIES
	$hide_sub_folders = get_option('mdocs-hide-subfolders');
	$hide_all_sub_folder = get_option('mdocs-hide-all-subfolders');
	if(!isset($att['cat']) && $hide_all_sub_folder == false) $num_cols = mdocs_display_sub_folders($current_cat_array, 'null'); 
	elseif(isset($current_cat_array['children']) && $hide_sub_folders == false && isset($att['cat'])) $num_cols = mdocs_display_sub_folders($current_cat_array, $att['cat']);
	// LOAD FILES
	$has_one_file = false;
	foreach($mdocs as $index => $the_mdoc) {
		if($the_mdoc['cat'] == $current_cat || $current_cat == 'all') {
			if(mdocs_check_file_rights($the_mdoc, false)) {
				$has_one_file = true;
				$mdocs_post = get_post($the_mdoc['parent']);
				mdocs_display_file_info($the_mdoc, $index, $current_cat);
			}
		} 
	}
	if($has_one_file == false && get_option('mdocs-show-no-file-found')) {
		?><tr><td colspan="<?php echo $num_tds; ?>"><p class="mdocs-nofiles" ><?php _e('No files found in this folder.','mdocs'); ?></p></td></tr><?php
	}
	?></table></div><?php
	$the_list = ob_get_clean();
	return $the_list;
}
?>